diff --git a/src/bin/pg_combinebackup/reconstruct.c b/src/bin/pg_combinebackup/reconstruct.c
new file mode 100644
index 0000000000..c774bf1842
--- /dev/null
+++ b/src/bin/pg_combinebackup/reconstruct.c
@@ -0,0 +1,618 @@
+/*-------------------------------------------------------------------------
+ *
+ * reconstruct.c
+ *		Reconstruct full file from incremental file and backup chain.
+ *
+ * Copyright (c) 2017-2023, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	  src/bin/pg_combinebackup/reconstruct.c
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres_fe.h"
+
+#include <unistd.h>
+
+#include "backup/basebackup_incremental.h"
+#include "common/logging.h"
+#include "common/file_perm.h"
+#include "copy_file.h"
+#include "reconstruct.h"
+#include "storage/block.h"
+
+/*
+ * An rfile stores the data that we need in order to be able to use some file
+ * on disk for reconstruction. For any given output file, we create one rfile
+ * per backup that we need to consult when we constructing that output file.
+ *
+ * If we find a full version of the file in the backup chain, then only
+ * filename and fd are initialized; the remaining fields are 0 or NULL.
+ * For an incremental file, header_length, num_blocks, relative_block_numbers,
+ * and truncation_block_length are also set.
+ *
+ * num_blocks_read and highest_offset_read always start out as 0.
+ */
+typedef struct rfile
+{
+	char	   *filename;
+	int			fd;
+	size_t		header_length;
+	unsigned	num_blocks;
+	BlockNumber *relative_block_numbers;
+	unsigned	truncation_block_length;
+	unsigned	num_blocks_read;
+	off_t		highest_offset_read;
+} rfile;
+
+static void debug_reconstruction(int n_source,
+								 rfile **sources,
+								 bool dry_run);
+static unsigned find_reconstructed_block_length(rfile *s);
+static rfile *make_incremental_rfile(char *filename);
+static rfile *make_rfile(char *filename, bool missing_ok);
+static void write_reconstructed_file(char *input_filename,
+									 char *output_filename,
+									 unsigned block_length,
+									 rfile **sourcemap,
+									 off_t *offsetmap,
+									 pg_checksum_context *checksum_ctx,
+									 bool dry_run);
+static void read_bytes(rfile *rf, void *buffer, unsigned length);
+
+/*
+ * Reconstruct a full file from an incremental file and a chain of prior
+ * backups.
+ *
+ * input_filename should be the path to the incremental file, and
+ * output_filename should be the path where the reconstructed file is to be
+ * written.
+ *
+ * relative_path should be the relative path to the directory containing this
+ * file. bare_file_name should be the name of the file within that directory,
+ * without "INCREMENTAL.".
+ *
+ * n_prior_backups is the number of prior backups, and prior_backup_dirs is
+ * an array of pathnames where those backups can be found.
+ */
+void
+reconstruct_from_incremental_file(char *input_filename,
+								  char *output_filename,
+								  char *relative_path,
+								  char *bare_file_name,
+								  int n_prior_backups,
+								  char **prior_backup_dirs,
+								  manifest_data **manifests,
+								  char *manifest_path,
+								  pg_checksum_type checksum_type,
+								  int *checksum_length,
+								  uint8 **checksum_payload,
+								  bool dry_run)
+{
+	rfile	  **source;
+	rfile	   *latest_source = NULL;
+	rfile	  **sourcemap;
+	off_t	   *offsetmap;
+	unsigned	block_length;
+	unsigned	num_missing_blocks;
+	unsigned	i;
+	unsigned	sidx = n_prior_backups;
+	bool		full_copy_possible = true;
+	int			copy_source_index = -1;
+	rfile	   *copy_source = NULL;
+	pg_checksum_context checksum_ctx;
+
+	/*
+	 * Every block must come either from the latest version of the file or
+	 * from one of the prior backups.
+	 */
+	source = pg_malloc0(sizeof(rfile *) * (1 + n_prior_backups));
+
+	/*
+	 * Use the information from the latest incremental file to figure out how
+	 * long the reconstructed file should be.
+	 */
+	latest_source = make_incremental_rfile(input_filename);
+	source[n_prior_backups] = latest_source;
+	block_length = find_reconstructed_block_length(latest_source);
+
+	/*
+	 * For each block in the output file, we need to know from which file we
+	 * need to obtain it and at what offset in that file it's stored.
+	 * sourcemap gives us the first of these things, and offsetmap the latter.
+	 */
+	sourcemap = pg_malloc0(sizeof(rfile *) * block_length);
+	offsetmap = pg_malloc0(sizeof(off_t) * block_length);
+
+	/*
+	 * Blocks prior to the truncation_block_length threshold must be obtained
+	 * from some prior backup, while those after that threshold are left as
+	 * zeroes if not present in the newest incremental file.
+	 * num_missing_blocks counts the number of blocks that we must be found
+	 * somewhere in the backup chain, and is thus initially equal to
+	 * truncation_block_length.
+	 */
+	num_missing_blocks = latest_source->truncation_block_length;
+
+	/*
+	 * Every block that is present in the newest incremental file should be
+	 * sourced from that file. If it precedes the truncation_block_length,
+	 * it's a block that we would otherwise have had to find in an older
+	 * backup and thus reduces the number of blocks remaining to be found by
+	 * one; otherwise, it's an extra block that needs to be included in the
+	 * output but would not have needed to be found in an older backup if it
+	 * had not been present.
+	 */
+	for (i = 0; i < latest_source->num_blocks; ++i)
+	{
+		BlockNumber b = latest_source->relative_block_numbers[i];
+
+		Assert(b < block_length);
+		sourcemap[b] = latest_source;
+		offsetmap[b] = latest_source->header_length + (i * BLCKSZ);
+		if (b < latest_source->truncation_block_length)
+			num_missing_blocks--;
+
+		/*
+		 * A full copy of a file from an earlier backup is only possible if no
+		 * blocks are needed from any later incremental file.
+		 */
+		full_copy_possible = false;
+	}
+
+	while (num_missing_blocks > 0)
+	{
+		char		source_filename[MAXPGPATH];
+		rfile	   *s;
+
+		/*
+		 * Move to the next backup in the chain. If there are no more, then
+		 * something has gone wrong and reconstruction has failed.
+		 */
+		if (sidx == 0)
+			pg_fatal("reconstruction for file \"%s\" failed to find %u required blocks",
+					 output_filename, num_missing_blocks);
+		--sidx;
+
+		/*
+		 * Look for the full file in the previous backup. If not found, then
+		 * look for an incremental file instead.
+		 */
+		snprintf(source_filename, MAXPGPATH, "%s/%s/%s",
+				 prior_backup_dirs[sidx], relative_path, bare_file_name);
+		if ((s = make_rfile(source_filename, true)) == NULL)
+		{
+			snprintf(source_filename, MAXPGPATH, "%s/%s/INCREMENTAL.%s",
+					 prior_backup_dirs[sidx], relative_path, bare_file_name);
+			s = make_incremental_rfile(source_filename);
+		}
+		source[sidx] = s;
+
+		/*
+		 * If s->header_length == 0, then this is a full file; otherwise, it's
+		 * an incremental file.
+		 */
+		if (s->header_length != 0)
+		{
+			/*
+			 * Since we found another incremental file, source all blocks from
+			 * it that we need but don't yet have.
+			 */
+			for (i = 0; i < s->num_blocks; ++i)
+			{
+				BlockNumber b = s->relative_block_numbers[i];
+
+				if (b < latest_source->truncation_block_length &&
+					sourcemap[b] == NULL)
+				{
+					sourcemap[b] = s;
+					offsetmap[b] = s->header_length + (i * BLCKSZ);
+
+					Assert(num_missing_blocks > 0);
+					--num_missing_blocks;
+
+					/*
+					 * A full copy of a file from an earlier backup is only
+					 * possible if no blocks are needed from any later
+					 * incremental file.
+					 */
+					full_copy_possible = false;
+				}
+			}
+		}
+		else
+		{
+			BlockNumber b;
+
+			/*
+			 * Since we found a full file, source all remaining required
+			 * blocks from it.
+			 */
+			for (b = 0; b < latest_source->truncation_block_length; ++b)
+			{
+				if (sourcemap[b] == NULL)
+				{
+					sourcemap[b] = s;
+					offsetmap[b] = b * BLCKSZ;
+
+					Assert(num_missing_blocks > 0);
+					--num_missing_blocks;
+				}
+			}
+			Assert(num_missing_blocks == 0);
+
+			/*
+			 * If a full copy looks possible, check whether the resulting file
+			 * should be exactly as long as the source file is. If so, a full
+			 * copy is acceptable, otherwise not.
+			 */
+			if (full_copy_possible)
+			{
+				struct stat sb;
+				uint64		expected_length;
+
+				if (fstat(s->fd, &sb) < 0)
+					pg_fatal("could not stat \"%s\": %m", s->filename);
+				expected_length =
+					(uint64) latest_source->truncation_block_length;
+				expected_length *= BLCKSZ;
+				if (expected_length == sb.st_size)
+				{
+					copy_source = s;
+					copy_source_index = sidx;
+				}
+			}
+		}
+	}
+
+	/*
+	 * If a checksum of the required type already exists in the
+	 * backup_manifest for the relevant input directory, we can save some work
+	 * by reusing that checksum instead of computing a new one.
+	 */
+	if (copy_source_index >= 0 && manifests[copy_source_index] != NULL &&
+		checksum_type != CHECKSUM_TYPE_NONE)
+	{
+		manifest_file *mfile;
+
+		mfile = manifest_files_lookup(manifests[copy_source_index]->files,
+									  manifest_path);
+		if (mfile == NULL)
+		{
+			/*
+			 * The directory is out of sync with the backup_manifest, so emit
+			 * a warning.
+			 */
+			pg_log_warning("\"%s/backup_manifest\" contains no entry for \"%s\"",
+						   prior_backup_dirs[copy_source_index],
+						   manifest_path);
+		}
+		else if (mfile->checksum_type == checksum_type)
+		{
+			*checksum_length = mfile->checksum_length;
+			*checksum_payload = pg_malloc(*checksum_length);
+			memcpy(*checksum_payload, mfile->checksum_payload,
+				   *checksum_length);
+			checksum_type = CHECKSUM_TYPE_NONE;
+		}
+	}
+
+	/* Prepare for checksum calculation, if required. */
+	pg_checksum_init(&checksum_ctx, checksum_type);
+
+	/*
+	 * If the full file can be created by copying a file from an older backup
+	 * in the chain without needing to overwrite any blocks or truncate the
+	 * result, then forget about performing reconstruction and just copy that
+	 * file in its entirety.
+	 *
+	 * Otherwise, reconstruct.
+	 */
+	if (copy_source != NULL)
+		copy_file(copy_source->filename, output_filename,
+				  &checksum_ctx, dry_run);
+	else
+	{
+		write_reconstructed_file(input_filename, output_filename,
+								 block_length, sourcemap, offsetmap,
+								 &checksum_ctx, dry_run);
+		debug_reconstruction(n_prior_backups + 1, source, dry_run);
+	}
+
+	/* Save results of checksum calculation. */
+	if (checksum_type != CHECKSUM_TYPE_NONE)
+	{
+		*checksum_payload = pg_malloc(PG_CHECKSUM_MAX_LENGTH);
+		*checksum_length = pg_checksum_final(&checksum_ctx,
+											 *checksum_payload);
+	}
+
+	/*
+	 * Close files and release memory.
+	 */
+	for (i = 0; i <= n_prior_backups; ++i)
+	{
+		rfile	   *s = source[i];
+
+		if (s == NULL)
+			continue;
+		if (close(s->fd) != 0)
+			pg_fatal("could not close \"%s\": %m", s->filename);
+		if (s->relative_block_numbers != NULL)
+			pfree(s->relative_block_numbers);
+		pg_free(s->filename);
+	}
+	pfree(sourcemap);
+	pfree(offsetmap);
+	pfree(source);
+}
+
+/*
+ * Perform post-reconstruction logging and sanity checks.
+ */
+static void
+debug_reconstruction(int n_source, rfile **sources, bool dry_run)
+{
+	unsigned	i;
+
+	for (i = 0; i < n_source; ++i)
+	{
+		rfile	   *s = sources[i];
+
+		/* Ignore source if not used. */
+		if (s == NULL)
+			continue;
+
+		/* If no data is needed from this file, we can ignore it. */
+		if (s->num_blocks_read == 0)
+			continue;
+
+		/* Debug logging. */
+		if (dry_run)
+			pg_log_debug("would have read %u blocks from \"%s\"",
+						 s->num_blocks_read, s->filename);
+		else
+			pg_log_debug("read %u blocks from \"%s\"",
+						 s->num_blocks_read, s->filename);
+
+		/*
+		 * In dry-run mode, we don't actually try to read data from the file,
+		 * but we do try to verify that the file is long enough that we could
+		 * have read the data if we'd tried.
+		 *
+		 * If this fails, then it means that a non-dry-run attempt would fail,
+		 * complaining of not being able to read the required bytes from the
+		 * file.
+		 */
+		if (dry_run)
+		{
+			struct stat sb;
+
+			if (fstat(s->fd, &sb) < 0)
+				pg_fatal("could not stat \"%s\": %m", s->filename);
+			if (sb.st_size < s->highest_offset_read)
+				pg_fatal("file \"%s\" is too short: expected %llu, found %llu",
+						 s->filename,
+						 (unsigned long long) s->highest_offset_read,
+						 (unsigned long long) sb.st_size);
+		}
+	}
+}
+
+/*
+ * When we perform reconstruction using an incremental file, the output file
+ * should be at least as long as the truncation_block_length. Any blocks
+ * present in the incremental file increase the output length as far as is
+ * necessary to include those blocks.
+ */
+static unsigned
+find_reconstructed_block_length(rfile *s)
+{
+	unsigned	block_length = s->truncation_block_length;
+	unsigned	i;
+
+	for (i = 0; i < s->num_blocks; ++i)
+		if (s->relative_block_numbers[i] >= block_length)
+			block_length = s->relative_block_numbers[i] + 1;
+
+	return block_length;
+}
+
+/*
+ * Initialize an incremental rfile, reading the header so that we know which
+ * blocks it contains.
+ */
+static rfile *
+make_incremental_rfile(char *filename)
+{
+	rfile	   *rf;
+	unsigned	magic;
+
+	rf = make_rfile(filename, false);
+
+	/* Read and validate magic number. */
+	read_bytes(rf, &magic, sizeof(magic));
+	if (magic != INCREMENTAL_MAGIC)
+		pg_fatal("file \"%s\" has bad incremental magic number (0x%x not 0x%x)",
+				 filename, magic, INCREMENTAL_MAGIC);
+
+	/* Read block count. */
+	read_bytes(rf, &rf->num_blocks, sizeof(rf->num_blocks));
+	if (rf->num_blocks > RELSEG_SIZE)
+		pg_fatal("file \"%s\" has block count %u in excess of segment size %u",
+				 filename, rf->num_blocks, RELSEG_SIZE);
+
+	/* Read truncation block length. */
+	read_bytes(rf, &rf->truncation_block_length,
+			   sizeof(rf->truncation_block_length));
+	if (rf->truncation_block_length > RELSEG_SIZE)
+		pg_fatal("file \"%s\" has truncation block length %u in excess of segment size %u",
+				 filename, rf->truncation_block_length, RELSEG_SIZE);
+
+	/* Read block numbers if there are any. */
+	if (rf->num_blocks > 0)
+	{
+		rf->relative_block_numbers =
+			pg_malloc0(sizeof(BlockNumber) * rf->num_blocks);
+		read_bytes(rf, rf->relative_block_numbers,
+				   sizeof(BlockNumber) * rf->num_blocks);
+	}
+
+	/* Remember length of header. */
+	rf->header_length = sizeof(magic) + sizeof(rf->num_blocks) +
+		sizeof(rf->truncation_block_length) +
+		sizeof(BlockNumber) * rf->num_blocks;
+
+	return rf;
+}
+
+/*
+ * Allocate and perform basic initialization of an rfile.
+ */
+static rfile *
+make_rfile(char *filename, bool missing_ok)
+{
+	rfile	   *rf;
+
+	rf = pg_malloc0(sizeof(rfile));
+	rf->filename = pstrdup(filename);
+	if ((rf->fd = open(filename, O_RDONLY | PG_BINARY, 0)) < 0)
+	{
+		if (missing_ok && errno == ENOENT)
+		{
+			pg_free(rf);
+			return NULL;
+		}
+		pg_fatal("could not open file \"%s\": %m", filename);
+	}
+
+	return rf;
+}
+
+/*
+ * Read the indicated number of bytes from an rfile into the buffer.
+ */
+static void
+read_bytes(rfile *rf, void *buffer, unsigned length)
+{
+	unsigned	rb = read(rf->fd, buffer, length);
+
+	if (rb != length)
+	{
+		if (rb < 0)
+			pg_fatal("could not read file \"%s\": %m", rf->filename);
+		else
+			pg_fatal("could not read file \"%s\": read only %d of %d bytes",
+					 rf->filename, (int) rb, length);
+	}
+}
+
+/*
+ * Write out a reconstructed file.
+ */
+static void
+write_reconstructed_file(char *input_filename,
+						 char *output_filename,
+						 unsigned block_length,
+						 rfile **sourcemap,
+						 off_t *offsetmap,
+						 pg_checksum_context *checksum_ctx,
+						 bool dry_run)
+{
+	int			wfd = -1;
+	unsigned	i;
+	unsigned	zero_blocks = 0;
+
+	/* Debugging output. */
+	if (dry_run)
+		pg_log_debug("would reconstruct \"%s\" (%u blocks, checksum %s)",
+					 output_filename, block_length,
+					 pg_checksum_type_name(checksum_ctx->type));
+	else
+		pg_log_debug("reconstructing \"%s\" (%u blocks, checksum %s)",
+					 output_filename, block_length,
+					 pg_checksum_type_name(checksum_ctx->type));
+
+	/* Open the output file, except in dry_run mode. */
+	if (!dry_run &&
+		(wfd = open(output_filename,
+					O_RDWR | PG_BINARY | O_CREAT | O_EXCL,
+					pg_file_create_mode)) < 0)
+		pg_fatal("could not open file \"%s\": %m", output_filename);
+
+	/* Read and write the blocks as required. */
+	for (i = 0; i < block_length; ++i)
+	{
+		uint8		buffer[BLCKSZ];
+		rfile	   *s = sourcemap[i];
+		unsigned	wb;
+
+		/* Update accounting information. */
+		if (s == NULL)
+			++zero_blocks;
+		else
+		{
+			s->num_blocks_read++;
+			s->highest_offset_read = Max(s->highest_offset_read,
+										 offsetmap[i] + BLCKSZ);
+		}
+
+		/* Skip the rest of this in dry-run mode. */
+		if (dry_run)
+			continue;
+
+		/* Read or zero-fill the block as appropriate. */
+		if (s == NULL)
+		{
+			/*
+			 * New block not mentioned in the WAL summary. Should have been an
+			 * uninitialized block, so just zero-fill it.
+			 */
+			memset(buffer, 0, BLCKSZ);
+		}
+		else
+		{
+			unsigned	rb;
+
+			/* Read the block from the correct source, except if dry-run. */
+			rb = pg_pread(s->fd, buffer, BLCKSZ, offsetmap[i]);
+			if (rb != BLCKSZ)
+			{
+				if (rb < 0)
+					pg_fatal("could not read file \"%s\": %m", s->filename);
+				else
+					pg_fatal("could not read file \"%s\": read only %d of %d bytes at offset %u",
+							 s->filename, (int) rb, BLCKSZ,
+							 (unsigned) offsetmap[i]);
+			}
+		}
+
+		/* Write out the block. */
+		if ((wb = write(wfd, buffer, BLCKSZ)) != BLCKSZ)
+		{
+			if (wb < 0)
+				pg_fatal("could not write file \"%s\": %m", output_filename);
+			else
+				pg_fatal("could not write file \"%s\": wrote only %d of %d bytes",
+						 output_filename, (int) wb, BLCKSZ);
+		}
+
+		/* Update the checksum computation. */
+		if (pg_checksum_update(checksum_ctx, buffer, BLCKSZ) < 0)
+			pg_fatal("could not update checksum of file \"%s\"",
+					 output_filename);
+	}
+
+	/* Debugging output. */
+	if (zero_blocks > 0)
+	{
+		if (dry_run)
+			pg_log_debug("would have zero-filled %u blocks", zero_blocks);
+		else
+			pg_log_debug("zero-filled %u blocks", zero_blocks);
+	}
+
+	/* Close the output file. */
+	if (wfd >= 0 && close(wfd) != 0)
+		pg_fatal("could not close \"%s\": %m", output_filename);
+}
diff --git a/src/bin/pg_combinebackup/reconstruct.h b/src/bin/pg_combinebackup/reconstruct.h
new file mode 100644
index 0000000000..c599a70d42
--- /dev/null
+++ b/src/bin/pg_combinebackup/reconstruct.h
@@ -0,0 +1,32 @@
+/*-------------------------------------------------------------------------
+ *
+ * reconstruct.h
+ *		Reconstruct full file from incremental file and backup chain.
+ *
+ * Copyright (c) 2017-2023, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	  src/bin/pg_combinebackup/reconstruct.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef RECONSTRUCT_H
+#define RECONSTRUCT_H
+
+#include "common/checksum_helper.h"
+#include "load_manifest.h"
+
+extern void reconstruct_from_incremental_file(char *input_filename,
+											  char *output_filename,
+											  char *relative_path,
+											  char *bare_file_name,
+											  int n_prior_backups,
+											  char **prior_backup_dirs,
+											  manifest_data **manifests,
+											  char *manifest_path,
+											  pg_checksum_type checksum_type,
+											  int *checksum_length,
+											  uint8 **checksum_payload,
+											  bool dry_run);
+
+#endif
diff --git a/src/bin/pg_combinebackup/write_manifest.c b/src/bin/pg_combinebackup/write_manifest.c
new file mode 100644
index 0000000000..82160134d8
--- /dev/null
+++ b/src/bin/pg_combinebackup/write_manifest.c
@@ -0,0 +1,293 @@
+/*-------------------------------------------------------------------------
+ *
+ * Write a new backup manifest.
+ *
+ * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/bin/pg_combinebackup/write_manifest.c
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres_fe.h"
+
+#include <fcntl.h>
+#include <time.h>
+#include <unistd.h>
+
+#include "common/checksum_helper.h"
+#include "common/file_perm.h"
+#include "common/logging.h"
+#include "lib/stringinfo.h"
+#include "load_manifest.h"
+#include "mb/pg_wchar.h"
+#include "write_manifest.h"
+
+struct manifest_writer
+{
+	char		pathname[MAXPGPATH];
+	int			fd;
+	StringInfoData buf;
+	bool		first_file;
+	bool		still_checksumming;
+	pg_checksum_context manifest_ctx;
+};
+
+static void escape_json(StringInfo buf, const char *str);
+static void flush_manifest(manifest_writer *mwriter);
+static size_t hex_encode(const uint8 *src, size_t len, char *dst);
+
+/*
+ * Create a new backup manifest writer.
+ *
+ * The backup manifest will be written into a file named backup_manifest
+ * in the specified directory.
+ */
+manifest_writer *
+create_manifest_writer(char *directory)
+{
+	manifest_writer *mwriter = pg_malloc(sizeof(manifest_writer));
+
+	snprintf(mwriter->pathname, MAXPGPATH, "%s/backup_manifest", directory);
+	mwriter->fd = -1;
+	initStringInfo(&mwriter->buf);
+	mwriter->first_file = true;
+	mwriter->still_checksumming = true;
+	pg_checksum_init(&mwriter->manifest_ctx, CHECKSUM_TYPE_SHA256);
+
+	appendStringInfo(&mwriter->buf,
+					 "{ \"PostgreSQL-Backup-Manifest-Version\": 1,\n"
+					 "\"Files\": [");
+
+	return mwriter;
+}
+
+/*
+ * Add an entry for a file to a backup manifest.
+ *
+ * This is very similar to the backend's AddFileToBackupManifest, but
+ * various adjustments are required due to frontend/backend differences
+ * and other details.
+ */
+void
+add_file_to_manifest(manifest_writer *mwriter, const char *manifest_path,
+					 size_t size, pg_time_t mtime,
+					 pg_checksum_type checksum_type,
+					 int checksum_length,
+					 uint8 *checksum_payload)
+{
+	int			pathlen = strlen(manifest_path);
+
+	if (mwriter->first_file)
+	{
+		appendStringInfoChar(&mwriter->buf, '\n');
+		mwriter->first_file = false;
+	}
+	else
+		appendStringInfoString(&mwriter->buf, ",\n");
+
+	if (pg_encoding_verifymbstr(PG_UTF8, manifest_path, pathlen) == pathlen)
+	{
+		appendStringInfoString(&mwriter->buf, "{ \"Path\": ");
+		escape_json(&mwriter->buf, manifest_path);
+		appendStringInfoString(&mwriter->buf, ", ");
+	}
+	else
+	{
+		appendStringInfoString(&mwriter->buf, "{ \"Encoded-Path\": \"");
+		enlargeStringInfo(&mwriter->buf, 2 * pathlen);
+		mwriter->buf.len += hex_encode((const uint8 *) manifest_path, pathlen,
+									   &mwriter->buf.data[mwriter->buf.len]);
+		appendStringInfoString(&mwriter->buf, "\", ");
+	}
+
+	appendStringInfo(&mwriter->buf, "\"Size\": %zu, ", size);
+
+	appendStringInfoString(&mwriter->buf, "\"Last-Modified\": \"");
+	enlargeStringInfo(&mwriter->buf, 128);
+	mwriter->buf.len += strftime(&mwriter->buf.data[mwriter->buf.len], 128,
+								 "%Y-%m-%d %H:%M:%S %Z",
+								 gmtime(&mtime));
+	appendStringInfoChar(&mwriter->buf, '"');
+
+	if (mwriter->buf.len > 128 * 1024)
+		flush_manifest(mwriter);
+
+	if (checksum_length > 0)
+	{
+		appendStringInfo(&mwriter->buf,
+						 ", \"Checksum-Algorithm\": \"%s\", \"Checksum\": \"",
+						 pg_checksum_type_name(checksum_type));
+
+		enlargeStringInfo(&mwriter->buf, 2 * checksum_length);
+		mwriter->buf.len += hex_encode(checksum_payload, checksum_length,
+									   &mwriter->buf.data[mwriter->buf.len]);
+
+		appendStringInfoChar(&mwriter->buf, '"');
+	}
+
+	appendStringInfoString(&mwriter->buf, " }");
+
+	if (mwriter->buf.len > 128 * 1024)
+		flush_manifest(mwriter);
+}
+
+/*
+ * Finalize the backup_manifest.
+ */
+void
+finalize_manifest(manifest_writer *mwriter,
+				  manifest_wal_range *first_wal_range)
+{
+	uint8		checksumbuf[PG_SHA256_DIGEST_LENGTH];
+	int			len;
+	manifest_wal_range *wal_range;
+
+	/* Terminate the list of files. */
+	appendStringInfoString(&mwriter->buf, "\n],\n");
+
+	/* Start a list of LSN ranges. */
+	appendStringInfoString(&mwriter->buf, "\"WAL-Ranges\": [\n");
+
+	for (wal_range = first_wal_range; wal_range != NULL;
+		 wal_range = wal_range->next)
+		appendStringInfo(&mwriter->buf,
+						 "%s{ \"Timeline\": %u, \"Start-LSN\": \"%X/%X\", \"End-LSN\": \"%X/%X\" }",
+						 wal_range == first_wal_range ? "" : ",\n",
+						 wal_range->tli,
+						 LSN_FORMAT_ARGS(wal_range->start_lsn),
+						 LSN_FORMAT_ARGS(wal_range->end_lsn));
+
+	/* Terminate the list of WAL ranges. */
+	appendStringInfoString(&mwriter->buf, "\n],\n");
+
+	/* Flush accumulated data and update checksum calculation. */
+	flush_manifest(mwriter);
+
+	/* Checksum only includes data up to this point. */
+	mwriter->still_checksumming = false;
+
+	/* Compute and insert manifest checksum. */
+	appendStringInfoString(&mwriter->buf, "\"Manifest-Checksum\": \"");
+	enlargeStringInfo(&mwriter->buf, 2 * PG_SHA256_DIGEST_STRING_LENGTH);
+	len = pg_checksum_final(&mwriter->manifest_ctx, checksumbuf);
+	Assert(len == PG_SHA256_DIGEST_LENGTH);
+	mwriter->buf.len +=
+		hex_encode(checksumbuf, len, &mwriter->buf.data[mwriter->buf.len]);
+	appendStringInfoString(&mwriter->buf, "\"}\n");
+
+	/* Flush the last manifest checksum itself. */
+	flush_manifest(mwriter);
+
+	/* Close the file. */
+	if (close(mwriter->fd) != 0)
+		pg_fatal("could not close \"%s\": %m", mwriter->pathname);
+	mwriter->fd = -1;
+}
+
+/*
+ * Produce a JSON string literal, properly escaping characters in the text.
+ */
+static void
+escape_json(StringInfo buf, const char *str)
+{
+	const char *p;
+
+	appendStringInfoCharMacro(buf, '"');
+	for (p = str; *p; p++)
+	{
+		switch (*p)
+		{
+			case '\b':
+				appendStringInfoString(buf, "\\b");
+				break;
+			case '\f':
+				appendStringInfoString(buf, "\\f");
+				break;
+			case '\n':
+				appendStringInfoString(buf, "\\n");
+				break;
+			case '\r':
+				appendStringInfoString(buf, "\\r");
+				break;
+			case '\t':
+				appendStringInfoString(buf, "\\t");
+				break;
+			case '"':
+				appendStringInfoString(buf, "\\\"");
+				break;
+			case '\\':
+				appendStringInfoString(buf, "\\\\");
+				break;
+			default:
+				if ((unsigned char) *p < ' ')
+					appendStringInfo(buf, "\\u%04x", (int) *p);
+				else
+					appendStringInfoCharMacro(buf, *p);
+				break;
+		}
+	}
+	appendStringInfoCharMacro(buf, '"');
+}
+
+/*
+ * Flush whatever portion of the backup manifest we have generated and
+ * buffered in memory out to a file on disk.
+ *
+ * The first call to this function will create the file. After that, we
+ * keep it open and just append more data.
+ */
+static void
+flush_manifest(manifest_writer *mwriter)
+{
+	char		pathname[MAXPGPATH];
+
+	if (mwriter->fd == -1 &&
+		(mwriter->fd = open(mwriter->pathname,
+							O_WRONLY | O_CREAT | O_EXCL | PG_BINARY,
+							pg_file_create_mode)) < 0)
+		pg_fatal("could not open file \"%s\": %m", mwriter->pathname);
+
+	if (mwriter->buf.len > 0)
+	{
+		ssize_t		wb;
+
+		wb = write(mwriter->fd, mwriter->buf.data, mwriter->buf.len);
+		if (wb != mwriter->buf.len)
+		{
+			if (wb < 0)
+				pg_fatal("could not write \"%s\": %m", mwriter->pathname);
+			else
+				pg_fatal("could not write file \"%s\": wrote only %d of %d bytes",
+						 pathname, (int) wb, mwriter->buf.len);
+		}
+
+		if (mwriter->still_checksumming)
+			pg_checksum_update(&mwriter->manifest_ctx,
+							   (uint8 *) mwriter->buf.data,
+							   mwriter->buf.len);
+		resetStringInfo(&mwriter->buf);
+	}
+}
+
+/*
+ * Encode bytes using two hexademical digits for each one.
+ */
+static size_t
+hex_encode(const uint8 *src, size_t len, char *dst)
+{
+	const uint8 *end = src + len;
+
+	while (src < end)
+	{
+		unsigned	n1 = (*src >> 4) & 0xF;
+		unsigned	n2 = *src & 0xF;
+
+		*dst++ = n1 < 10 ? '0' + n1 : 'a' + n1 - 10;
+		*dst++ = n2 < 10 ? '0' + n2 : 'a' + n2 - 10;
+		++src;
+	}
+
+	return len * 2;
+}
diff --git a/src/bin/pg_combinebackup/write_manifest.h b/src/bin/pg_combinebackup/write_manifest.h
new file mode 100644
index 0000000000..8fd7fe02c8
--- /dev/null
+++ b/src/bin/pg_combinebackup/write_manifest.h
@@ -0,0 +1,33 @@
+/*-------------------------------------------------------------------------
+ *
+ * Write a new backup manifest.
+ *
+ * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/bin/pg_combinebackup/write_manifest.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef WRITE_MANIFEST_H
+#define WRITE_MANIFEST_H
+
+#include "common/checksum_helper.h"
+#include "pgtime.h"
+
+struct manifest_wal_range;
+
+struct manifest_writer;
+typedef struct manifest_writer manifest_writer;
+
+extern manifest_writer *create_manifest_writer(char *directory);
+extern void add_file_to_manifest(manifest_writer *mwriter,
+								 const char *manifest_path,
+								 size_t size, pg_time_t mtime,
+								 pg_checksum_type checksum_type,
+								 int checksum_length,
+								 uint8 *checksum_payload);
+extern void finalize_manifest(manifest_writer *mwriter,
+							  struct manifest_wal_range *first_wal_range);
+
+#endif							/* WRITE_MANIFEST_H */
diff --git a/src/bin/pg_resetwal/pg_resetwal.c b/src/bin/pg_resetwal/pg_resetwal.c
index e7ef2b8bd0..f35302e994 100644
--- a/src/bin/pg_resetwal/pg_resetwal.c
+++ b/src/bin/pg_resetwal/pg_resetwal.c
@@ -85,6 +85,7 @@ static void RewriteControlFile(void);
 static void FindEndOfXLOG(void);
 static void KillExistingXLOG(void);
 static void KillExistingArchiveStatus(void);
+static void KillExistingWALSummaries(void);
 static void WriteEmptyXLOG(void);
 static void usage(void);
 
@@ -488,6 +489,7 @@ main(int argc, char *argv[])
 	RewriteControlFile();
 	KillExistingXLOG();
 	KillExistingArchiveStatus();
+	KillExistingWALSummaries();
 	WriteEmptyXLOG();
 
 	printf(_("Write-ahead log reset\n"));
@@ -1029,6 +1031,40 @@ KillExistingArchiveStatus(void)
 		pg_fatal("could not close directory \"%s\": %m", ARCHSTATDIR);
 }
 
+/*
+ * Remove existing WAL summary files
+ */
+static void
+KillExistingWALSummaries(void)
+{
+#define WALSUMMARYDIR XLOGDIR	"/summaries"
+#define WALSUMMARY_NHEXCHARS	40
+
+	DIR		   *xldir;
+	struct dirent *xlde;
+	char		path[MAXPGPATH + sizeof(WALSUMMARYDIR)];
+
+	xldir = opendir(WALSUMMARYDIR);
+	if (xldir == NULL)
+		pg_fatal("could not open directory \"%s\": %m", WALSUMMARYDIR);
+
+	while (errno = 0, (xlde = readdir(xldir)) != NULL)
+	{
+		if (strspn(xlde->d_name, "0123456789ABCDEF") == WALSUMMARY_NHEXCHARS &&
+			strcmp(xlde->d_name + WALSUMMARY_NHEXCHARS, ".summary") == 0)
+		{
+			snprintf(path, sizeof(path), "%s/%s", WALSUMMARYDIR, xlde->d_name);
+			if (unlink(path) < 0)
+				pg_fatal("could not delete file \"%s\": %m", path);
+		}
+	}
+
+	if (errno)
+		pg_fatal("could not read directory \"%s\": %m", WALSUMMARYDIR);
+
+	if (closedir(xldir))
+		pg_fatal("could not close directory \"%s\": %m", ARCHSTATDIR);
+}
 
 /*
  * Write an empty XLOG file, containing only the checkpoint record
diff --git a/src/common/Makefile b/src/common/Makefile
index e4cd26762b..ef38cc2f03 100644
--- a/src/common/Makefile
+++ b/src/common/Makefile
@@ -48,6 +48,7 @@ LIBS += $(PTHREAD_LIBS)
 OBJS_COMMON = \
 	archive.o \
 	base64.o \
+	blkreftable.o \
 	checksum_helper.o \
 	compression.o \
 	config_info.o \
